# encoding: utf-8
module PinganApi
  class AssistanceBusiness < PinganApi::Base

    # 接收平安银行推送过来的救援请求
    def receive_salvation(body)
      return PinganApi::Models::Assistance::SalvationReceiveRequest.from_xml(body)
    end

    # 返回数据给平安
    def receive_salvation_response(data)
      return data.get_result(PinganApi.config.salvation_receive_response_template)
    end

    # 发送救援执行情况给平安银行
    def send_operation(operation)
      data = send_request_with_data_and_template(operation, PinganApi.config.operation_send_request_template)
      return PinganApi::Models::Assistance::OperationSendResponse.from_xml(data)
    end

    # 向平安银行查询指定的救援请求
    def query_salvation(salvation_query)
      data = send_request_with_data_and_template(salvation_query, PinganApi.config.salvation_query_request_template)
      return PinganApi::Models::Assistance::SalvationQueryResponse.from_xml(data)
    end

    # 发送照片
    def send_photo(photo)
      data = send_request_with_data_and_template(photo, PinganApi.config.upload_photo_send_request_template)
      return PinganApi::Models::Assistance::OperationSendResponse.from_xml(data)
    end
  end
end